local base = {}
base.__index = base
local function new(x,y,load)

    local eSources,level,controlDistance,efficiency,maxClimb,wSpacing,mass,connections,ores,metals,material,energy,energyLeft,cpu,speed
      local wSpacing=35

    local img=love.graphics.newImage("wheel.png")
    if load then
        eSources=load.eSources
        level=load.level
        controlDistance=load.controlDistance
        efficiency=load.efficiency
        maxClimb=load.maxClimb
        wSpacing=load.wSpacing
        mass=load.mass
        connections=load.connections
        ores=load.ores
        metals=load.metals
        material=load.material
        energy=load.energy
        energyLeft=load.energyLeft
        cpu=load.cpu
        x=load.x
        y=load.y
        speed=load.speed
    else
        eSources={eSource[1] }
        controlDistance=1000
        efficiency=0.06
        level=1
        maxClimb=4
        wSpacing=35
        x={x,x+wSpacing*2}
        y={-1,y }
        mass=600
        metals={{materials.metals[1],100,0},{materials.metals[2],100,0} }
        ores={}
        connections={}
        material=90000
        energy=500
        energyLeft=500
        cpu={amount=20,max=20,level=1,generate=0.1,convert=10}
        speed=10
    end
    return setmetatable({eSources=eSources,level=level,mode='base',controlDistance=controlDistance,efficiency=efficiency,img=img,maxClimb=maxClimb,wSpacing=wSpacing,decks={},mass=mass,simSpeed=8,simX={0,0},simY={0,0},cDeck={1,1},moving=false,connections=connections,ores=ores,selectedMetal=1,metals=metals,material=material,energy=energy,energyLeft=energyLeft,cpu=cpu,x=x,y=y,ticker=0,speed=speed}, base)
end
function base:save()
    return {eSources=self.eSources,level=self.level,controlDistance=self.controlDistance,efficiency=self.efficiency,maxClimb=self.maxClimb,wSpacing=self.wSpacing,mass=self.mass,connections=self.connections,ores=self.ores,metals=self.metals,material=self.material,energy=self.energy,energyLeft=self.energyLeft,cpu=self.cpu,x=self.x,y=self.y,speed=self.speed}
end
function base:update(dt)
    if not self.moving then
        if (self.y[1]==-1) then
            self.y[1]=currentMap.soilLevel[math.floor(self.x[1]/4)]*4
            self.y[2]=currentMap.soilLevel[math.floor(self.x[2]/4)]*4
        end
        self.ticker=self.ticker+dt*50
        if (self.ticker>self.speed) then
            self.ticker=0
           --[[ if self.cpu.amount<self.cpu.max then
                if self:checkCost(self.cpu.generate*self.cpuConvert,0,0) then
                    self.cpu.amount=self.cpu.amount+self.cpu.generate
                    gi:setResources(self.material,self.energyLeft,self.cpu.amount,research.CPUneed)
                end
            end]]--
            for i,v in ipairs(self.connections) do
                if v[5]=='connecting' then
                    local xOffset=v[3]-v[1]
                    local yOffset=v[4]-v[2]

                    if (math.sqrt(yOffset*yOffset+xOffset*xOffset)<24) then
                            table.insert(v[6],v[3])
                            table.insert(v[6],v[4])
                            v[7].connected=true
                            v[5]='connected'
                        else

                                if (math.abs(yOffset)>math.abs(xOffset))then
                                  v[1]=v[1]+math.random(-5,5)
                                  v[2]=v[2]+math.sign(yOffset)*math.random(8,16)
                                else
                                    v[1]=v[1]+math.sign(xOffset)*math.random(8,16)
                                    v[2]=v[2]+math.random(-5,5)
                                end
                                if not currentMap:isSolid(currentMap:checkPoint(v[1],v[2])) then
                                    v[2]=v[2]+12
                                end
                            table.insert(v[6],v[1])
                            table.insert(v[6],v[2])
                    end
                end
            end
        end
    else
        self.ticker=self.ticker+dt*50
        if (self.ticker>self.simSpeed) then
            self.ticker=0
            local xNext=math.floor(self.simX[1]/4)+1
            local bridgeStart=self.decks[1][1]
            local bridgeEnd=self.decks[#self.decks][3]
            local cacheLoads={}
            local speed=0
            for wheel=1,2 do
                local oldY=self.simY[wheel]
                local xN=xNext*4+(wheel-1)*self.wSpacing*2
                if xN>bridgeEnd and wheel==1 then
                    self.moving=false
                    self.connections={}
                    brg:simSuccess()
                elseif xN>bridgeStart and xN<bridgeEnd then

                        if not self:checkDeck(self.decks[self.cDeck[wheel]][5]) then
                            break
                        end
                        local x1,y1,x2,y2=self.decks[self.cDeck[wheel]][5].joint:getAnchors()
                        if xN>x2 and self.cDeck[wheel]<#self.decks then
                            self.cDeck[wheel]=self.cDeck[wheel]+1
                            if not self:checkDeck(self.decks[self.cDeck[wheel]][5]) then
                                break
                            end
                            x1,y1,x2,y2=self.decks[self.cDeck[wheel]][5].joint:getAnchors()
                        end
                        local percent=(xN-x1)/(x2-x1)
                        self.simX[wheel]=xN

                        self.simY[wheel]=percent*(y2-y1)+y1
                        cacheLoads[math.floor(self.cDeck[wheel]*2)]=(cacheLoads[math.floor(self.cDeck[wheel]*2+1)] or 0) + math.floor(percent*self.mass/2)
                        cacheLoads[math.floor(self.cDeck[wheel]*2+1)]=(cacheLoads[math.floor(self.cDeck[wheel]*2+1)] or 0) + math.floor((1-percent)*self.mass/2)
                        speed=speed+oldY-self.simY[wheel]
                elseif xN>bridgeEnd+128 then
                    self.moving=false
                    brg:toNextLevel()
                else
                    self.simX[wheel]=xN
                    self.simY[wheel]=currentMap.soilLevel[math.floor(xN/4)]*4
                end
            end

            self.simSpeed=math.max(speed/2+9,5)
            if self.simSpeed>(self.maxClimb+9) then
                self.moving=false
                gi:logText('Deck gradient too steep!','bridge')
                brg:simFail()
                return false
            end
            if self.simSpeed>9 then
            self.simSpeed=9+(self.simSpeed-9)*3
            end
            for i,v in pairs(cacheLoads) do
                    local beam=self.decks[math.floor(i/2)][5]
                    if (i%2)==0 then
                        beam.j1:setLoad(v)
                    else
                        beam.j2:setLoad(v)
                    end
            end
        end
    end
end
function base:checkDeck(d)
    if not d.active then
        self.moving=false
        gi:logText('Bridge structural failure detected.','bridge')
        brg:simFail()
        return false
    end
    return true
end
function base:checkClick(x,y)
    local xy=cam:worldCoords(x,y)
    x,y=xy.x,x,xy.y
    if mag(x-(self.x[1]+self.x[2])/2,y-(self.y[1]+self.y[2])/2)<300 then
       self:click('self')
    end
end
function base:setPosition(x)
    self.x[1]=x-self.wSpacing
    self.y[1]=currentMap.soilLevel[math.floor(self.x[1]/4)]*4
    self.x[2]=x+self.wSpacing
    self.y[2]=currentMap.soilLevel[math.floor(self.x[2]/4)]*4
end
function base:startSim(decks)
    self.cDeck={1,1}
    self.moving=true
    self.decks=decks
    self.simX[1]=currentMap.wStart-self.wSpacing-164
    self.simY[1]=currentMap.soilLevel[math.floor(self.simX[1]/4)]*4-4
    self.simX[2]=currentMap.wStart+self.wSpacing-164
    self.simY[2]=currentMap.soilLevel[math.floor(self.simX[2]/4)]*4-4
end
function base:resetEnergy()
    self.energyLeft=self.energy
    gi:setResources(self.material,self.energyLeft,self.cpu.amount,res.CPUneed)
end
function base:endSim()
    self.moving=false
end
function base:draw()
    local x1,y1,x2,y2
    if self.moving then
        x1,y1,x2,y2=self.simX[1],self.simY[1],self.simX[2],self.simY[2]
    else
        x1,y1,x2,y2=self.x[1],self.y[1],self.x[2],self.y[2]
        love.graphics.setLineStyle('smooth')
        love.graphics.setColor(220,55,25,115)
        love.graphics.setLineWidth(4)
        for i,v in ipairs(self.connections) do
            if (#v[6]>=4) then
                love.graphics.line(v[6])
            end
        end
    end
    love.graphics.setColor(180,180,180,255)
    local ang=math.atan2(y1-y2,x1-x2)
    local height=20
    love.graphics.push()
    love.graphics.translate(x1,(y1-height))
    love.graphics.rotate(ang+math.pi/2)
    love.graphics.translate(-x1,-(y1-height))

    local width=x2-x1
    love.graphics.rectangle('fill',x1,y1-height,height/2,width)
    love.graphics.pop()

    love.graphics.setColor(255,255,255,255)
    love.graphics.draw(self.img,x1-10,y1-20)
    love.graphics.draw(self.img,x2-10,y2-20)
end

function base:click(item)
    if item==201 then
        gi:drawDialogMats('ore',self.ores)
    elseif item==202 then
        gi:drawDialogMats('metal',self.metals)
    elseif item==203 then
        gi:drawDialogEnergy(self.energy)
    elseif item==204 then
        gi:drawDialogCPU(self.cpu.amount)
    elseif item=='self'then
        if self.mode=='base' then
            gi:openMissionMenu()
        end
    end

end
function base:addMineral(oreType,amount)
    local ore=realM[oreType]
    self.material=self.material+ore.soilType*amount
    local found=false
    for i,v in ipairs(self.ores) do
        if v[1]==ore then
           v[2]=v[2]+amount
           found=true
        end
    end
    if not found then
       table.insert(self.ores,{ore,amount})
    end
    self:forgeMetals()
    gi:setResources(self.material,self.energyLeft,self.cpu.amount,res.CPUneed)
end
function base:checkCost(m,e,cpu)
    cpu=cpu or 0
    if self.material>=m and self.energyLeft>=e and self.cpu.amount>=cpu then
        self.material=self.material-m
        self.energyLeft=self.energyLeft-e
        self.cpu.amount=self.cpu.amount-cpu
        gi:setResources(self.material,self.energyLeft,self.cpu.amount,res.CPUneed)
        return true
    else
        gi:logText('Not enough resources.','base')
        return false
    end

end
function base:forgeMetals()
    for i,v in ipairs(self.ores) do
        if v[2]>0 then
           for ind,met in ipairs(v[1].composeOf) do
               if type(met[1].tensile)=='number' then
                   self:useSelectedMetal(met[1],-met[2]*self.efficiency*v[2])
               end
           end
           v[2]=0
        end
    end
end
function base:connect(building)
    local midX=(self.x[1]+self.x[2])/2
    local midY=(self.y[1]+self.y[2])/2-20

    table.insert(self.connections,{midX,midY,building.x,building.y+building.height,'connecting',{midX,midY},building})
end
function base:getSelectedMetal()
   return self.metals[self.selectedMetal][1]
end
function base:getMetalLeft()
    return self.metals[self.selectedMetal][2]
end
function base:getMetalLeftFor(i)
    return self.metals[i][2]
end
function base:getMetalUsedForBridge(i)
    return self.metals[i][3]
end
function base:resetMetalUsedForBridge(i)
    for i,v in ipairs(self.metals) do
              v[3]=0
    end
    gi:updateBridgeMode()
end
function base:useSelectedMetal(metal,amount)

    for i,v in ipairs(self.metals) do
        if v[1]==metal then
             v[3]=v[3]-amount
             gi:updateBridgeMode()
             return
        end
    end
    table.insert(self.metals,{metal,-amount,0})
    gi:updateBridgeMode()
end
function base:upgradeCPU()
    gi:logText('CPU upgraded.','base')
end
function base:buildEnergy(v)
    if (v.have==v.limit) then
        gi:logText('Reached building limit','base')
        return false
    end
end
function base:getEnergySources()
    return self.eSources
end
function base:changeMode(mode)
    self:resetEnergy()
    self.mode=mode
    self.y[1]=-1
end
return setmetatable({new = new},
    {__call = function(_, ...) return new(...) end})