local dirt = {}
dirt.__index = dirt
local function new(x,y,type,direction,building)
    --local bod = {}
    --bod.b = love.physics.newBody(world.obj, 650/2, 650/2, 15, 0) --place the body in the center of the world, with a mass of 15
    --bod.s = love.physics.newCircleShape(bod.b, 0, 0, 20) --the ball's shape has no offset from it's body and has a radius of 20
    local x=x
    local y=y
    local type=type
    local xSpeed=0
    local ySpeed=0
    if (direction~='dissolve') then
        xSpeed=math.random(80,130)*direction
        ySpeed=math.random(-450,-350)
    end
    return setmetatable({settle=false,type=type,xSpeed=xSpeed,ySpeed=ySpeed,x=x,y=y,onGround=false,animationFrame=0,direction=direction,building=building}, dirt)
end
function dirt:updatedirt(dt)

end

function dirt:draw()
    love.graphics.translate(-currentMap.startX*4,0)
    love.graphics.setPointSize(4)
    if self.direction~='dissolve' and self.settle~=true then
        love.graphics.setColor(mats[self.type][1],mats[self.type][2],mats[self.type][3])
        love.graphics.point(self.x,self.y);
    elseif self.settle~=true then
        love.graphics.setColor(255,0,0,255)
        love.graphics.setPointSize(2)
        love.graphics.setLineWidth(1)
        for i=1,4-self.animationFrame do
            if math.abs(self.animationFrame-i)<0.05 then
                love.graphics.line(self.x+1+(i%2)*2,self.y+1+2*math.floor(i/2),self.building.x,self.building.y);
            end
            love.graphics.point(self.x+1+(i%2)*2,self.y+1+2*math.floor(i/2));
        end
        self.animationFrame=self.animationFrame+0.01
        if self.animationFrame>=4 then
           self.settle=true
           mainBase:addMineral(self.type,1)
            self:delete()
        end
        love.graphics.setPointSize(4)
    end
    love.graphics.translate(currentMap.startX*4,0)

end
function dirt:moveSide(direction)
    self.xSpeed=direction*3
end

function dirt:moveUp()
    if (self.onGround) then
        self.ySpeed=-10
        self.onGround=false;
    end
end
function dirt:newCollision(a,coll)
    self.onGround=true;
end

function dirt:update(dt)
    if self.settle or self.direction=='dissolve' then
        return
    end
    self.x,self.y,self.xSpeed,self.ySpeed,self.onGround=updateObject(self.x,self.y,self.xSpeed,self.ySpeed,dt,20);
    if self.onGround or (self.xSpeed==0 and self.ySpeed==0)then
        local tX,tY=toGrid(self.x,self.y)
        for i=-3,20 do
            if currentMap:isSolid(currentMap:checkPoint(tX,tY+i,1)) and not currentMap:isSolid(currentMap:checkPoint(tX,tY+i-1,1)) then
                if currentMap:isSolid(currentMap:checkPoint(tX,tY+i+1,1)) then
                    self.x=tX*4
                    self.y=tY+i-1
                    currentMap:setPoint(tX,tY+i-1,self.type)
                    self.settle=true
                    self:delete()
                    break;
                end
            end
        end
    end
end
function dirt:delete()
    table.deleteObject(objects.dirt,i)
end
function drawTerrainPoint(x,y,tMat)
    love.graphics.setCanvas(frameBuffer)
    love.graphics.setPoint(4, "rough")
    if type(tMat)~=number then
        tMat=tiles[x][y]
    end
    love.graphics.setColor(mats[tMat][1],mats[tMat][2],mats[tMat][3])
    love.graphics.point(x*4+2,y*4+2);
    love.graphics.setCanvas()
end

return setmetatable({new = new},
    {__call = function(_, ...) return new(...) end})