local gui = {}
gui.__index = gui
local function new()
    local menuOptions={
        {'Bu' },
        {'Br'},
        {'Bae'},
        {'Re'}

    }

    love.graphics.setFont(fonts.small)
    local guiX=math.floor(world.screenX-430)
    local guiY=math.floor(world.screenY-160)
    local menu=love.graphics.newCanvas(world.screenX,world.screenY);
    local fb = love.graphics.newCanvas(world.screenX,160);
    local fbd= love.graphics.newCanvas(430,400);
    local fbb= love.graphics.newCanvas(200,550);
    local fResources = love.graphics.newCanvas(430,20);
    local pointer={pointer=love.graphics.newImage("pointer.png"),normal=love.graphics.newImage("normal.png"),}
    return setmetatable({dialogs={},alwaysButtons={},cursor='normal',cursorImg=pointer,loading=false,dialogButtons={},menu=menu,updateBridge=false,textBuffer={{'Game loaded','none'}},fbb=fbb,changed=true,currentSubject={},mat=1000,energy=500,cpu=20,CPUneed=20,dialogOpen=false,fb=fb,fbd=fbd,fResources=fResources,guiX=guiX,guiY=guiY,selectedMenu=-1,menuOptions=menuOptions}, gui)
end

function gui:draw()
    if gameMode=='game' then
        self:drawResources()
        love.graphics.setColor(colours.white)
        love.graphics.draw(self.fb,0,self.guiY)
        love.graphics.draw(self.fResources,self.guiX,0)
        if self.dialogOpen then
            love.graphics.draw(self.fbd,(world.screenX-430)/2,200)
            for i,v in ipairs(self.dialogs) do
                love.graphics.setColor(colours.white)
                love.graphics.draw(v,0,0)
            end
        end
        if (self.selectedMenu==2) then
              if self.updateBridge then
                  self:drawBridgeMode()
                  self.updateBridge=false
              end
              love.graphics.setColor(colours.white)
              love.graphics.draw(self.fbb,(world.screenX-200),25)
        end


        love.graphics.setColor(colours.text)
        self:drawConsole()

    else
        love.graphics.setColor(colours.white)
        love.graphics.draw(self.menu,0,0)
    end
    self:drawMouse()
end
function gui:drawMouse()
    if self.cursor=='pointer'then
        love.graphics.setColor(colours.white)
        love.graphics.draw(self.cursorImg.pointer,self.mouseX-4,self.mouseY)
    elseif self.cursor=='normal' then
        love.graphics.setColor(colours.white)
        love.graphics.draw(self.cursorImg.normal,self.mouseX,self.mouseY)
    end
end
function gui:drawConsole()
    if self.consoleOpen then
        local height=#self.textBuffer*20+20
        love.graphics.setColor(colours.dialogBackground)
        love.graphics.rectangle('fill',0,world.screenY-height,world.screenX-465,height)
        love.graphics.setColor(colours.text)
        for i=1,#self.textBuffer do
            love.graphics.print(self.textBuffer[i][1],10,world.screenY-i*20-5)
        end
    else
        love.graphics.print(self.textBuffer[#self.textBuffer][1],10,world.screenY-25)
    end
end

function gui:logText(text,type)
    table.insert(self.textBuffer,{text,type})
    if (#self.textBuffer>25) then
        table.remove(self.textBuffer,1)
    end
end
function gui:update(dt)
    self.mouseX,self.mouseY=love.mouse.getX(),love.mouse.getY()
    local test=self:getLocation(self.mouseX,self.mouseY)
end
function gui:updateBridgeMode()
     self.updateBridge=true
end
function gui:drawBridgeMode()
    self.bridgeButtons={}
    love.graphics.setCanvas(self.fbb)
    love.graphics.setColor(colours.dialogBackground)
    love.graphics.rectangle('fill',0,0,200,130)
    self:drawButton(5,5,200,20,brg.modeText,nil,self.bridgeButtons,world.screenX-200,25)
    self:drawButton(5,30,200,20,'Toggle Grid',nil,self.bridgeButtons,world.screenX-200,25)
    self:drawButton(5,55,200,20,'Toggle Forces',nil,self.bridgeButtons,world.screenX-200,25)
    self:drawButton(5,80,200,20,'Undo (z)',nil,self.bridgeButtons,world.screenX-200,25)
    self:drawButton(5,105,200,20,'Reset',nil,self.bridgeButtons,world.screenX-200,25)
    love.graphics.setColor(colours.dialogBackground)
    local height=135

    for i,v in ipairs(mainBase.metals) do
        local m=v[1]
        if (mainBase.selectedMetal==i) then
            love.graphics.setColor(150,150,150,255)
        else
            love.graphics.setColor(230,230,230,255)
        end
        local localHeight=height
        love.graphics.rectangle('fill',0,height,200,100)
        love.graphics.setColor(0,0,0,255)
        love.graphics.setFont(fonts.medium)
        height=height+5
        love.graphics.print(m.name:gsub("^%l", string.upper),5,height)
        love.graphics.setFont(fonts.small)
        local mLeft=math.floor(mainBase:getMetalLeftFor(i)+mainBase:getMetalUsedForBridge(i))
        if mLeft<0 then
            love.graphics.setColor(255,0,0,255)
        end
        love.graphics.print(mLeft..' kg left',85,height)
        height=height+20
        if (mainBase.selectedMetal==i) then
            self:drawProgressBar(65,height,130,8,(m.mass-levelsMass[1])/levelsMass[7],{180,50,50})
            love.graphics.print('Weight',5,height)

            height=height+15
            self:drawProgressBar(65,height,130,8,(m.compressive-levelsCompressive[1])/levelsCompressive[7],{50,50,180})
            love.graphics.print('Compress.',5,height)

            height=height+15
            self:drawProgressBar(65,height,130,8,(m.tensile-levelsTensile[1])/levelsTensile[7],{50,180,50})
            love.graphics.print('Tensile',5,height)

            height=height+15
            self:drawProgressBar(65,height,130,8,(m.young-levelsYoung[1])/levelsYoung[7],{180,180,50})
            love.graphics.print('Rigidity',5,height)
            height=height+15
        end
        table.insert(self.bridgeButtons,{world.screenX-200,25+localHeight,200,height-localHeight,i})
    end
    love.graphics.setBlendMode('subtractive')
    love.graphics.rectangle('fill',0,height,200,400)
    love.graphics.setBlendMode('alpha')

    love.graphics.setCanvas()
end
function gui:clickBridgeButton(t)
    if t=='Simulate' then
        brg:simulate()
    elseif t=='Cancel Simulation' or t=='Sim Failed' then
        brg:cancelSimulate()
    elseif t=='Cross Bridge' then
        brg:cross()
    elseif t=='Toggle Grid' then
        brg:toggleGrid()
    elseif t=='Toggle Forces' then
        brg.showForces=not brg.showForces
    elseif t=='Undo (z)' then
        brg:undo()
    elseif t=='Reset' then
        brg:reset(false)
    elseif type(t)=='number' then
        mainBase.selectedMetal=t
        self:updateBridgeMode()
    end
end
function gui:openDialog(buttons)

    love.graphics.setCanvas(self.fbd)
    self.fbd:clear()
    local marginX=(world.screenX-430)/2
    local marginY=200
    local borderY=10
    local borderX=10
    local width=430
    local height=borderY
    self.dialogButtons={}

    love.graphics.setColor(colours.dialogBackground)
    love.graphics.rectangle('fill',0,0,width,400)
    love.graphics.setColor(colours.text)
    love.graphics.setFont(fonts.medium)
    for i,v in ipairs(buttons) do
        height=self:drawElement(v,borderX,width-borderX*2,height,marginX,marginY)
    end
    height = height+20+borderY
    self:drawButton(width-15,5,10,10,'x',nil,1,marginX,marginY,function() gi:closeDialog() end)
    love.graphics.setBlendMode('subtractive')
    love.graphics.rectangle('fill',0,height,430,400)
    love.graphics.setBlendMode('alpha')
    love.graphics.setCanvas()

    self.dialogOpen=true


end


function gui:drawElement(v,x,width,height,marginX,marginY,colour)
    marginX=marginX or 0
    marginY=marginY or 0
    if colour then
        love.graphics.setColor(colour)
    else
        love.graphics.setColor(colours.text)
    end
    if v[1]=='sub' then
        love.graphics.setFont(fonts.large)
        love.graphics.print(v[2],x,height)
        love.graphics.setFont(fonts.medium)
    elseif v[1]=='text' then
        love.graphics.print(v[2]..': '..v[3],x,height)
    elseif v[1]=='textDesc' then
        love.graphics.print(v[2],x,height)
    elseif v[1]=='textDescLong' then
        love.graphics.printf(v[2],x,height,width)
        height = height+15
    elseif v[1]=='choose' then
        love.graphics.print(v[2],x,height)
        self:drawButton(x+width/2,height,width/2,20,'Choose')
        table.insert(self.dialogButtons,{marginX+x+width/2,marginY+height,width/2,20,v[3],v[4]})
    elseif v[1]=='functionButton' then
        self:drawButton(x+width/4,height,width/2,20,v[2],nil,1,marginX,marginY,v[3])
    end
    height=height+25
    return height
end

function gui:checkClick(x,y)
    local location=self:getLocation(x,y)
    for i,v in ipairs(self.alwaysButtons) do
        if x>v[1] and x<(v[1]+v[3]) and y>v[2] and y<(v[2]+v[4]) then
            v[6]()
            return true
        end
    end

    if location=='dialogButtons' then
       for i,v in ipairs(self.dialogButtons) do
            if x>v[1] and x<(v[1]+v[3]) and y>v[2] and y<(v[2]+v[4]) then
                    v[6]()
                    return true
            end
       end

    elseif location=='menuB' and mainBase.mode=='base' then
        local varY=(y-self.guiY-8)/27
        if varY%1<(24/27)then
            local item=math.ceil(varY)
            if item~=2 then
                self:clickMenu(item)
                return true
            end
        end
    elseif location=='menuTab' then
        local varX=(x-self.guiX-10)/70
        local varY=(y-self.guiY-17)/70
        if varX%1<(6/7) and varY%1<(6/7)then
           self:click(math.ceil(varX)+(math.ceil(varY)-1)*6)
           return true
        end
    elseif location=='bridgeButtons' then
        for i,v in ipairs(self.bridgeButtons) do
            if x>v[1] and x<(v[1]+v[3]) and y>v[2] and y<(v[2]+v[4]) then
                self:clickBridgeButton(v[5])
                return true
            end
        end
    end
    return false
end
function gui:getLocation(x,y)
    local opt=''
    if self.dialogOpen then
        self.cursor='pointer'
        opt='dialogButtons'
    elseif x>(self.guiX-27) and x<(self.guiX-3) and y>(self.guiY+8) then
        self.cursor='pointer'
        opt='menuB'
    elseif (x>self.guiX and y>self.guiY) then
        self.cursor='pointer'
        opt='menuTab'
    elseif x>world.screenX-200 and y<575 and self.selectedMenu==2 then
        self.cursor='pointer'
        opt='bridgeButtons'
    else
        self.cursor='normal'
        opt='none'
    end
    return opt
end
function gui:drawResources()
    if self.changed then
        love.graphics.setCanvas(self.fResources)
        self.fResources:clear()
        love.graphics.rectangle('line',0,0,430,20)
        love.graphics.setColor(200, 200, 200)
        love.graphics.rectangle('fill',0,0,430,20)
        love.graphics.setColor(220, 220, 220)
        love.graphics.rectangle('fill',0,140,world.screenX-435,20)
        love.graphics.setColor(0,0,0,255)
        love.graphics.setFont(fonts.large)
        love.graphics.print('Material: '..self.mat,10,5)
        love.graphics.print('Energy: '..self.energy,150,5)
        love.graphics.print('CPU: '..self.cpu..'/'..self.CPUneed,270,5)
        love.graphics.setFont(fonts.medium)
        love.graphics.setCanvas()
        self.changed=false
    end

end
function gui:setResources(mat,energy,cpu,CPUneed)
    self.mat=math.round(mat)
    self.energy=math.round(energy)
    self.cpu=math.round(cpu)
    self.cpuNeed=math.round(CPUneed)
    self.changed=true
end
function gui:clickMenu(item)
    if (item~=self.selectedMenu) then

        love.graphics.setFont(fonts.medium)
        love.graphics.setCanvas(self.fb)
        self.fb:clear()
        self.dialogButtons={}
        self.alwaysButtons={}
        if mainBase.mode=='base' then
            self:drawButton(5,160-70,150,30,'Mission Selection',nil,self.alwaysButtons,0,self.guiY,function() gi:openMissionMenu() end)
        else
            self:drawButton(5,160-70,150,30,'Back To Base',nil,self.alwaysButtons,0,self.guiY,function() loadBaseLevel(false) end)
        end
        love.graphics.setColor(colours.dialogBackground)
        love.graphics.rectangle('fill',self.guiX,0,600,200)
        love.graphics.setColor(colours.dialogFrame)
        love.graphics.rectangle('line',self.guiX,0,600,200)
        love.graphics.setColor(colours.dialogBackground)
        love.graphics.rectangle('fill',0,125,world.screenX-465,35)

        local bX=0
        local bY=0
        if item==1 then

            love.graphics.setColor(0, 0, 0,255)
            love.graphics.print('Build Buildings',self.guiX+5,0+5)
            for i=1,5 do
                bX=self.guiX+10+((i-1)%6)*70
                bY=17+math.floor((i-1)/6)*70
                love.graphics.setColor(120, 120, 120)
                if not buildingTypes[i].available then
                    love.graphics.setColor(200, 200, 200,255)
                end
                love.graphics.rectangle('fill',bX,bY,60,60)
                love.graphics.setColor(0, 0, 0,255)

                love.graphics.printf(buildingTypes[i].name,bX,bY+10,60,'center')
            end
        elseif item==2 then
            love.graphics.setColor(0, 0, 0,255)
            love.graphics.print('Bridge Building Mode',self.guiX+5,0+5)
            for i=1,7 do
                bX=self.guiX+10+((i-1)%6)*70
                bY=17+math.floor((i-1)/6)*70
                love.graphics.setColor(120, 120, 120)
                if not buildingTypes[i+100].available then
                    love.graphics.setColor(200, 200, 200,255)
                end
                love.graphics.rectangle('fill',bX,bY,60,60)
                love.graphics.setColor(0, 0, 0,255)
                love.graphics.printf(buildingTypes[i+100].name,bX,bY+10,60,'center')

            end
            self:updateBridgeMode()
        elseif item==3 then
            love.graphics.setColor(0, 0, 0,255)
            love.graphics.print('You',self.guiX+5,0+5)
            for i=1,4 do
                bX=self.guiX+10+((i-1)%6)*70
                bY=17+math.floor((i-1)/6)*70
                love.graphics.setColor(120, 120, 120)
                if not buildingTypes[i+200].available then
                    love.graphics.setColor(200, 200, 200,255)
                end
                love.graphics.rectangle('fill',bX,bY,60,60)
                love.graphics.setColor(0, 0, 0,255)
                love.graphics.printf(buildingTypes[i+200].name,bX,bY+10,60,'center')
            end
        elseif item==4 then
            love.graphics.setColor(0, 0, 0,255)
            love.graphics.print('Research',self.guiX+5,0+5)
            for i=1,8 do
                bX=self.guiX+10+((i-1)%6)*70
                bY=17+math.floor((i-1)/6)*70
                love.graphics.setColor(120, 120, 120)
                if not buildingTypes[i+300].available then
                    love.graphics.setColor(200, 200, 200,255)
                end
                love.graphics.rectangle('fill',bX,bY,60,60)
                love.graphics.setColor(0, 0, 0,255)
                love.graphics.printf(buildingTypes[i+300].name,bX,bY+10,60,'center')
            end
        end
        love.graphics.setColor(160, 160, 160)
        love.graphics.rectangle('fill',self.guiX-30,5,30,155)
        if (item~=2) then
            for i,v in ipairs(self.menuOptions) do
                bX=self.guiX-27
                bY=7+(i-1)*27
                love.graphics.setColor(120, 120, 120)
                love.graphics.rectangle('fill',bX,bY,24,24)
                love.graphics.setColor(0, 0, 0,255)
                love.graphics.print(v[1],bX,bY)
            end
        end
        love.graphics.setCanvas()
    end
    self.selectedMenu=item
end
function gui:click(item)
       item=item+100*(self.selectedMenu-1)
        if type(buildingTypes[item])~='table' then
            return
        end
        if buildingTypes[item].available==false then
            return
        end
        if item<200 then
        buildingToPlace=building(item)

        elseif item>200 and item<300  then
            mainBase:click(item)
        else
            res:click(item)
        end

end
function gui:closeDialog()
    self.dialogOpen=false
    self.dialogs={}
end

function gui:drawDialogMats(type,mat)
    local tempAr={}
        for i,v in ipairs(mat) do
            table.insert(tempAr,{'sub',v[1].name:gsub("^%l", string.upper)})
            table.insert(tempAr,{'textDescLong',v[1].description})
        end

        self:openDialog(tempAr)
end

function gui:drawDialogEnergy(e)
    local tempAr={{'sub','Energy'},
        {'textDescLong','Energy is required to do anything. Upgrade or research to gain more energy.'},
    }
    local build=mainBase:getEnergySources()
    for i,v in ipairs(build) do
       table.insert(tempAr,{'choose',v.name..' '..v.have..'/'..v.limit..' ','Build ('..v.cost..')',function() mainBase:buildEnergy(v) end})
    end
    self:openDialog(tempAr)
end
function gui:drawDialogCPU(c)
    local tempAr={{'sub','CPU'},
    {'textDescLong','Processing power is needed for research. You use energy to convert materials into processing power.'},
    {'slider','Max CPU',0,200,mainBase.maxCpu},
    {'choose','CPU level: '..mainBase.cpuLevel,'Upgrade', function()  mainBase:upgradeCPU() end },
    }

    self:openDialog(tempAr)
end


function gui:drawButton(x,y,width,height,text,colour,button,offsetX,offsetY,func)
    colour=colour or colours.buttonBackground
    love.graphics.setColor(colour[1],colour[2],colour[3],255)
    love.graphics.rectangle('fill',x,y,width,height)
    love.graphics.setColor(colours.text)
    love.graphics.setFont(fonts.large)
    love.graphics.printf(text,x,y+(height-20)/2,width,'center')
    love.graphics.setFont(fonts.medium)
    if type(button)=='table' then
        table.insert(button,{x+offsetX,y+offsetY,width,height,text,func})
    elseif button then
       --print(text..' '..(x+offsetX)..' '..(y+offsetY)..' '..width..' '..height)
        table.insert(self.dialogButtons,{x+offsetX,y+offsetY,width,height,text,func})
    end
end
function gui:drawProgressBar(x,y,width,height,percent,colour)

    love.graphics.setColor(200,200,200,255)
    love.graphics.rectangle('fill',x,y,width,height)
    colour=colour or {170,170,170}
    love.graphics.setColor(colour[1],colour[2],colour[3],255)
    love.graphics.rectangle('fill',x,y,width*percent,height)
end
function gui:showSuccessScren()
    local w,h=500,300
    local x,y=self:newDialogBox(w,h)

    local border=10
    love.graphics.setColor(colours.text)
    love.graphics.setFont(fonts.large)
    love.graphics.printf('Success!',x,y+border,w,'center')
    love.graphics.setCanvas()

end
function gui:openMissionMenu()
    local w,h=800,500
    local x,y=self:newDialogBox(w,h)

    local border=10
    love.graphics.setColor(colours.text)
    love.graphics.setFont(fonts.large)
    love.graphics.printf('Choose Mission',x,y+border,w,'center')
    love.graphics.printf('Current Level: '..mainBase.level,x,y+border+20,w,'center')
    local height=45
    love.graphics.setFont(fonts.medium)
    love.graphics.setColor(colours.dialogFrame)
    love.graphics.rectangle('fill',x+border,y+border+height,(w-border*3)/2,h-border*2-height)

    love.graphics.rectangle('fill',x+(w-border*3)/2+border*2,y+border+height,(w-border*3)/2,h-border*2-height)

    love.graphics.push()
    love.graphics.translate(x,y)
    local result=currentMap:getMissions(mainBase.level)
    for i,v in ipairs(result) do
        local w1,h1=(w-border*3)/2-border*2,border*2+height
        local x1,y1=border*2+(w1+border*3)*(i-1),border*2
        local disp={'sub','Water Bodies'}
        h1=self:drawElement(disp,x1,w1,h1,x,y)
        local disp={'textDesc','Total Water bodies: '..#v}
        h1=self:drawElement(disp,x1,w1,h1,x,y)
        local distance = 0
         for w,wat in ipairs(v) do
            distance=distance+wat[2]
        end
        local disp={'textDesc','Total Distance to span: '..distance}
        h1=self:drawElement(disp,x1,w1,h1,x,y)
        local disp={'sub','Reward'}
        h1=self:drawElement(disp,x1,w1,h1,x,y)
        local disp={'textDesc',v.reward..' CPU'}
        h1=self:drawElement(disp,x1,w1,h1,x,y)
    end
    table.insert(self.dialogButtons,{x+border,y+border+height,(w-border*3)/2,h-border*2-height,' ',function() loadMissionLevel(result[1]) end})
    table.insert(self.dialogButtons,{x+(w-border*3)/2+border*2,y+border+height,(w-border*3)/2,h-border*2-height,' ',function() loadMissionLevel(result[2]) end})
    love.graphics.pop()
    love.graphics.setCanvas()
end
function gui:displayResearch(result)
    local w,h=800,500
    local x,y=self:newDialogBox(w,h)
    local border=10

    love.graphics.setColor(colours.text)
    love.graphics.setFont(fonts.large)
    love.graphics.printf('Choose Research',x,y+border,w,'center')
    local height=25
    love.graphics.setFont(fonts.medium)
    love.graphics.setColor(colours.dialogFrame)
    love.graphics.rectangle('fill',x+border,y+border+height,(w-border*3)/2,h-border*2-height)
    table.insert(self.dialogButtons,{x+border,y+border+height,(w-border*3)/2,h-border*2-height,' ',function() res:choose(1) end})
    love.graphics.rectangle('fill',x+(w-border*3)/2+border*2,y+border+height,(w-border*3)/2,h-border*2-height)
    table.insert(self.dialogButtons,{x+(w-border*3)/2+border*2,y+border+height,(w-border*3)/2,h-border*2-height,' ',function() res:choose(2) end})
    love.graphics.push()
    love.graphics.translate(x,y)
    for i,v in ipairs(result) do
        local w1,h1=(w-border*3)/2-border*2,border*2+height
        local x1,y1=border*2+(w1+border*3)*(i-1),border*2
        local disp={'sub','Choice '..i}
        h1=self:drawElement(disp,x1,w1,h1,x,y)
        h1=h1+20
        local disp={'sub','Effects'}
        h1=self:drawElement(disp,x1,w1,h1,x,y)
        for j,k in ipairs(v) do
            local str=math.round(k.strength,1)
            local colour={255,50,50}
            if k.strength>0 then
                colour=colours.text
                str='+'..k.strength,1
            end
            local disp={'textDesc',k.description..' '..str..'%'}
            h1=self:drawElement(disp,x1,w1,h1,x,y,colour)

        end
    end
    love.graphics.pop()
    love.graphics.setCanvas()
end
function gui:newDialogBox(w,h)
    self.dialogButtons={}
    self.dialogOpen=true
    local diag=love.graphics.newCanvas(world.screenX,world.screenY);
    local x,y=(world.screenX-w)/2,(world.screenY-h)/2,
    love.graphics.setCanvas(diag)
    love.graphics.setColor(colours.dialogBackground)
    love.graphics.rectangle('fill',x,y,w,h)
    love.graphics.setColor(colours.dialogOutline)
    love.graphics.rectangle('line',x,y,w,h)
    table.insert(self.dialogs,diag)
    self:drawButton(w-15+x,5+y,10,10,'x',nil,1,0,0,function() gi:closeDialog() end)
    return x,y
end
function gui:drawMainMenu()
    self.dialogOpen=true
    love.graphics.setCanvas(self.menu)
    self.menu:clear()
    love.graphics.setColor(colours.white)
    love.graphics.setFont(fonts.huge)
    local menuWidth=400
    local x1=(world.screenX-menuWidth)/2
    local x2=(world.screenX+menuWidth)/2
    local height=200
    love.graphics.printf('Needs A Name',x1,height,menuWidth,'center')
    height=height+80
    self:drawButton(x1,height,menuWidth,40,'Continue',colours.white,1,0,0,function() loadGame(1) end)
    height=height+80
    self:drawButton(x1,height,menuWidth,40,'New Game',colours.white,1,0,0,function() startNewGame() end)
    height=height+80
    self:drawButton(x1,height,menuWidth,40,'Load Game',colours.white,1,0,0,function() loadGame(0) end)
    height=height+80
    self:drawButton(x1,height,menuWidth,40,'Options',colours.white,1,0,0,function() loadGame(0) end)
    height=height+80
    self:drawButton(x1,height,menuWidth,40,'Exit',colours.white,1,0,0,function() os.exit() end)
    height=height+80

    love.graphics.setCanvas()

end
function gui:drawLoadingScreen()
    if not self.loading then
        love.graphics.setCanvas(self.menu)
        self.menu:clear()
        love.graphics.setFont(fonts.huge)
        love.graphics.print('Loading...',50,world.screenY-80)
        love.graphics.setCanvas()
        self.loading=true
        self.dialogOpen=false
        return true
    else
        return false
     end
end

return setmetatable({new = new},
    {__call = function(_, ...) return new(...) end})