local joint = {}
joint.__index = joint
local function new(x,y,mass,cannotMove)
    if cannotMove then
        mass=0
    end
    local mobile="dynamic"
    if mass==0 then
        mobile="static"
    end
    local body=love.physics.newBody(world.obj, x, y,mobile)
    --local shape=love.physics.newRectangleShape(1,1)
    --local fixture=love.physics.newFixture(body,shape,mass)
    body:setLinearDamping(1)
    body:setMassData(0,0,mass,0)
    return setmetatable({mass=mass,load=0,active=true,body=body,mobile=mobile}, joint)
end

function joint:draw()
    if (self.active) then
        love.graphics.point(self.body:getX(),self.body:getY())
    end
end
function joint:setLoad(load)
    if self.mobile=='dynamic' then
        self.load=load
        self.body:setMassData(0,0,self.mass+self.load,0)
    end
end
function joint:reduceLoad(load)
    if self.mobile=='dynamic' then
        self.load=math.max(0,self.load-load)
        self.body:setMassData(0,0,self.mass+self.load,0)
    end
end
function joint:setMass(mass)
    if self.mobile=='dynamic' then
        self.mass=mass
        self.body:setMassData(0,0,self.mass,0)
    end
end
function joint:getMass()
    return self.mass
end
function joint:increaseMass(mass)
    self:setMass(self.mass+mass)
end
function joint:destroy()
     table.deleteObject(brg.joints,self)
     self.body:destroy()
     self.active=false
end


return setmetatable({new = new},
    {__call = function(_, ...) return new(...) end})