local light = {}
light.__index = light
local function new(x,y,strength,size)
    x,y=toGrid(x,y)
    return setmetatable({x=x,y=y,strength=strength,size=size}, light)
end

function light:draw(pLights)
    love.graphics.setCanvas(currentMap.nb)
    love.graphics.setBlendMode("additive")
    love.graphics.setPointSize(4)
    for i=self.x-self.size,self.x+self.size do
        for j=self.y-self.size,self.y+self.size do
            local distance=mag(i-self.x,j-self.y)
            local alpha=math.min(math.max(0,510-((distance*2)/self.size)*255),255)
            --alpha=math.min(255,alpha*(alpha/self.strength))
            love.graphics.setColor(0,0,0,alpha)
            love.graphics.point((i-currentMap.startX)*4,j*4)
        end
    end
    love.graphics.setBlendMode('alpha')
    love.graphics.setCanvas()
end
function initLight(x,y,strength,size)

end
function blendLights()
    love.graphics.setColor(255,255,255,255)
    currentMap.lb:clear()

    love.graphics.setCanvas(currentMap.lb)
    love.graphics.draw(currentMap.pb,0,0)
    love.graphics.setBlendMode("subtractive")

    love.graphics.draw(currentMap.nb,0,0)

    love.graphics.setBlendMode("alpha")
    love.graphics.setCanvas()
end
return setmetatable({new = new},
    {__call = function(_, ...) return new(...) end})