require 'common'
require 'hump.class'
require'compress'
require'serial'
player=require 'player'
dirt=require'dirt'
gui=require'gui'
building=require'building'
base=require'base'
light=require'light'
ore=require'ore'
metal=require'metal'
mapGen=require'map'
research=require'research'
tech=require'tech'
hump={}
hump.camera=require 'hump.camera';
hump.gamestate=require 'hump.gamestate';
hump.timer=require 'hump.timer';
hump.vector=require 'hump.vector';
baseMap={}
missionLevels={}
lightBuffer={}
negativeBuffer={}
positiveLights={}
buildingBuffer={}

topLayer={}
currentMap={}
world={}
realM={}
objects = {}
objects.ground = {}
objects.dirt={}
objects.buildings={}
objects.lights={}
objects.buttons={}
bridgeM=require'bridge'
lookingForConnection=-1
fonts={}
debugOn=false
fonts.small=love.graphics.newFont( 'Gotham-Medium.ttf', 9)
fonts.medium=love.graphics.newFont( 'Gotham-Medium.ttf', 12)
fonts.large=love.graphics.newFont( 'Gotham-Medium.ttf', 16)
fonts.huge=love.graphics.newFont( 'Gotham-Medium.ttf', 48)
gameMode='menu'
buildingTypes={
    {name='Shaft',
         place={-3,'down'},
         description='Digs Downwards',
         material=200,
         energy=50,
         speed=15,
        lightStrength=35,
        crush=4,
         available=true,
         options={{'choose','Output','outputDirt'},{'choose','Wall reinforcement','wallMaterial'}},
    },
    {name='Dirt Rerouter',
        place={-3,'down'},
        description='Reroutes Dirt',
        material=50,
        energy=20,
        speed=50,
        available=false,
        options={{'choose','Input','inputDirt'},{'slider','Direction',5},{'slider','Blow Strength',6}},
    },
    {name='Tunnel',
        place={-3,'down'},
        description='Digs Sideways',
        material=200,
        energy=50,
        speed=30,
        options={},
        lightStrength=35,
        available=false,
    },
    {name='Ore Extractor',
        place={-3,'down'},
        description='Digs Downwards',
        material=200,
        energy=50,
        speed=30,
        maxDistance=30,

        available=true,
        options={{'choose','Output','outputMineral'},{'choose','Mine mineral type','mineral'}},
    },
    {name='Light',
        place={-3,'down'},
        description='Reroutes Dirt',
        material=50,
        energy=20,
        speed=50,
        available=true,
        lightStrength=55,
        options={{'choose','Input','inputDirt'},{'slider','Direction',5},{'slider','Blow Strength',6}},
    },
    [101]={name='Anchor',
        place={-3,'down'},
        description='Anchors bridge',
        material=300,
        energy=50,
        speed=50,
        options={},
        available=true,
    },
    [102]={name='Beam (b)',
        place={0,'point'},
        description='Standard bridge building block',
        drawWidth=4,
        options={},
        maxLength=70,
        strength=1,
        mass=1,
        cost=1,
        available=true,
    },
    [103]={name='Heavy Beam',
        place={0,'point'},
        description='Heavy beams are expensive but much longer and stronger than normal beams',

        drawWidth=6,
        options={},
        maxLength=150,
        strength=3,
        mass=2,
        cost=4,
        available=false,
    },
    [104]={name='Cable',
        place={0,'point'},
        description='Lightweight and strong but you can\'t push a rope!',
        drawWidth=1,
        maxLength=1400,
        strength=1.5,
        mass=0.1,
        cost=0.3,
        available=true,
    },
    [105]={name='Heavy Cable',
        place={0,'point'},
        description='Fat cable, perfect for suspension bridges',
        drawWidth=4,
        options={},
        maxLength=1400,
        strength=10,
        mass=0.5,
        cost=1,
        available=false,
    },
    [106]={name='Deck',
        place={0,'point'},
        description='Needed for you to cross to the next island',
        drawWidth=4,
        options={},
        maxLength=70,
        strength=1.2,
        mass=1.3,
        cost=1.2,
        available=true,
    },
    [107]={name='Delete',
        place={0,'beam'},
        description='Delete bridge element',
        available=true,
    },
    [201]={name='Ores',
        description='Ores you have mined.',
        available=true,
    },
    [202]={name='Metals',
        description='Forge metals and alloys',
        available=true,

    },
    [203]={name='Energy',
        description='Energy management',
        available=true,

    },
    [204]={name='Cpu',
        description='CPU management',
        available=true,
    },
    [301]={name='Building Mining',
        description='Improve your building mining.',
        available=true,
    },
    [302]={name='Building Exploration',
        description='Improve your base and resource processing abilities.',
        available=true,
    },
    [303]={name='Building Efficiency',
        description='Improve your building efficiency.',
        available=true,
    },
    [304]={name='Bridge elements',
        description='Improve your bridges.',
        available=true
    },
    [305]={name='Base Stats',
        description='Improve your base.',
        available=true
    },
    [306]={name='Base Energy',
        description='Improve your energy.',
        available=true
    },
    [307]={name='Base CPU',
        description='Improve your CPU.',
        available=true
    },
    [308]={name='Science',
        description='Improve your science.',
        available=true
    },
}
materials={}
materials.soils={}
materials.woods={}
materials.ores={}
materials.metals={}
beam=require'beam'
joint=require'joint'
buildingToPlace=-1
function love.load()
    --initial graphics setup
    world.width=4096
    world.height=3072
    local modes=love.graphics.getModes()
    table.sort(modes, function(a, b) return a.width*a.height < b.width*b.height end)
    love.graphics.setMode(modes[#modes].width,modes[#modes].height,false, true, 0)
    love.graphics.setBackgroundColor(0,0,0)
    world.screenX=love.graphics.getWidth()
    world.screenY=love.graphics.getHeight()
    love.physics.setMeter(64)
    world.obj = love.physics.newWorld(0,400,true)
    gi=gui()
    love.mouse.setVisible(false)
    gi:drawMainMenu()
end


function love.update(dt)
    hump.timer.update(dt)
    gi:update(dt)
    if gameMode=='game' then

        updateMouseStatus()
        --mainPlayer:update(dt)
        mainBase:update(dt)
        updateDirt(dt)

        if love.keyboard.isDown('a') or love.keyboard.isDown('left') then
            scrollCam(-10,0)
        elseif love.keyboard.isDown('d') or love.keyboard.isDown('right') then
            scrollCam(10,0)
        elseif love.keyboard.isDown('w') or love.keyboard.isDown('up') then
            scrollCam(0,-10)
        elseif love.keyboard.isDown('s') or love.keyboard.isDown('down') then
            scrollCam(0,10)
        end

        for i,v in ipairs(objects.buildings) do
            v:update(dt)
        end
        if buildingToPlace~=-1 then
            buildingToPlace:update(dt)
        end
        brg:update(dt)
    end
end
function love.keypressed(key)   -- we do not need the unicode, so we can leave it out

    if key=='p' then
        debugOn=not debugOn
    elseif key=='g' then
        --currentMap:generateNextLevel()
    elseif key=='`' then
        gi.consoleOpen=not gi.consoleOpen
    elseif key=='z' then
        brg:undo()
    elseif key=='b' then
        buildingToPlace=building(102)
    elseif key=='escape' then
        goToMenu()

    end
end
  function goToMenu()
      gameMode='menu'
      gi:drawMainMenu()
  end
function love.draw()

    if gameMode=='game' then
        cam:attach()

        love.graphics.setColor(72, 160, 14) -- set the drawing color to green for the ground
        --love.graphics.polygon("fill", objects.ground.s:getPoints()) -- draw a "filled in" polygon using the ground's coordinates
        love.graphics.setColor(255,255,255,255)
        currentMap:draw()
        for i,v in ipairs(objects.dirt) do
            v:draw()
        end

        for i,v in ipairs(objects.buildings) do
            v:draw()
        end
        love.graphics.setColor(255,255,255,255)
        mainBase:draw();
        love.graphics.setColor(255,255,255,255)
        brg:draw()
        love.graphics.setColor(255,255,255,255)
        --mainPlayer:draw();

        cam:detach()

        cam:attach()
        if buildingToPlace~=-1 then
            love.graphics.setColor(255,255,255,150)
            buildingToPlace:draw()
        end
        love.graphics.setColor(255,255,255,225)


        cam:detach()

    end
    gi:draw()
    if debugOn then
        love.graphics.setColor(0,0,0,255)
        love.graphics.print(love.timer.getFPS(),5,5)
    end
end
function love.mousepressed(x, y, button)
    if button=="l" then
        local checkC=gi:checkClick(x,y)
            if buildingToPlace~=-1 then
               buildingToPlace:place()
            else
                for i,v in ipairs(objects.buildings) do
                    if(x>v.x and x<v.x+v.width and y>v.y and y<v.y+v.height) then
                        v:clickActive()
                        return
                    end
                end
                if gameMode=='game' then
                    mainBase:checkClick(x,y)
                end
            end
        --end
    elseif button=="r" then
        buildingToPlace=-1
        gi.cursor='building'
    end
end

function setupBackground()
    materials.metals={
        metal(math.random(1,2),math.random(1,2),math.random(1,2),math.random(1,4)),
        metal(math.random(1,2),math.random(1,2),math.random(1,2),math.random(1,4)),

        metal(math.random(1,3),math.random(1,3),math.random(1,3),math.random(1,4)),
        metal(math.random(1,3),math.random(1,3),math.random(1,3),math.random(1,4)),

        metal(math.random(2,4),math.random(2,4),math.random(2,4),math.random(2,4)),
        metal(math.random(1,5),math.random(1,5),math.random(1,5),math.random(1,5)),

        metal(math.random(2,4),math.random(2,4),math.random(2,4),math.random(2,4)),
        metal(math.random(1,5),math.random(1,5),math.random(1,5),math.random(1,5)),

        metal(math.random(2,5),math.random(2,5),math.random(2,5),math.random(2,5)),
        metal(math.random(1,7),math.random(1,7),math.random(1,7),math.random(1,7)),

        metal(math.random(2,5),math.random(4,5),math.random(4,5),math.random(4,5)),
        metal(math.random(1,5),math.random(4,7),math.random(4,7),math.random(4,7)),
    }

    materials.soils={
        ore('soil',1,22),
        ore('soil',2,23),
        ore('soil',3,24),
        ore('soil',4,25),
        ore('soil',5,26),
        ore('soil',6,27),
    }
    local countOre=0
    for i,v in ipairs(materials.soils) do
        local oreTypes=math.random(1,3)
        for j=1,oreTypes do
           table.insert(materials.ores,ore('ore',i,countOre+28))
           countOre=countOre+1
        end
    end


    mats={{72, 160, 14,'grass'},     --grass
            {72, 160, 14,'wood2'},
            {72, 160, 14,'wood3'},
            {72, 160, 14,'wood4'},
            materials.metals[1].colour,  --5
            materials.metals[2].colour,
            materials.metals[3].colour,
            materials.metals[4].colour,
            materials.metals[5].colour,
            materials.metals[6].colour,  --10
            materials.metals[7].colour,
            materials.metals[8].colour,
            materials.metals[9].colour,
            materials.metals[10].colour,
            materials.metals[11].colour, --15
            materials.metals[12].colour,
            {176, 152, 76,'rock'},
            {72, 160, 14,'rock1'},
            {72, 160, 14,'rock2'},
            {72, 160, 14,'rock3'}, --20
            {72, 160, 14,'rock4'},
            materials.soils[1].colour,
            materials.soils[2].colour,
            materials.soils[3].colour,
            materials.soils[4].colour,  --25
            materials.soils[5].colour,
            materials.soils[6].colour, }
    for i,v in ipairs(materials.ores) do
            table.insert(mats,v.colour)
    end
    realM={{72, 160, 14,'grass'},     --grass
        {72, 160, 14,'wood2'},
        {72, 160, 14,'wood3'},
        {72, 160, 14,'wood4'},
        materials.metals[1],  --5
        materials.metals[2],
        materials.metals[3],
        materials.metals[4],
        materials.metals[5],
        materials.metals[6],  --10
        materials.metals[7],
        materials.metals[8],
        materials.metals[9],
        materials.metals[10],
        materials.metals[11], --15
        materials.metals[12],
        {176, 152, 76,'rock'},
        {72, 160, 14,'rock1'},
        {72, 160, 14,'rock2'},
        {72, 160, 14,'rock3'}, --20
        {72, 160, 14,'rock4'},
        materials.soils[1],
        materials.soils[2],
        materials.soils[3],
        materials.soils[4],  --25
        materials.soils[5],
        materials.soils[6],}
    for i,v in ipairs(materials.ores) do
        table.insert(realM,v)
    end
    mats[256]={139, 196, 244,'sky'}
    mats[255]={139, 196, 244,'sky'}
    mats[254]={27, 142, 249,'water'}
    mats[253]={127, 142, 249,'ladder'}
    mats[252]={127, 142, 249,'utility'}
    currentMap=mapGen()
    currentMap:generateBase()
    scrollCam(10,0)
end
function scrollCam(x,y)
    if x>0 then
        if (cam:cameraCoords(0,0).x<=world.screenX-currentMap.endX*4+8) then
            x=0
        end
    elseif x<0 then
        if (cam:cameraCoords(0,0).x>=-(currentMap.startX-currentMap.showPrevious)*4-8) then
            x=0
        end
    elseif y<0 then
        if (cam:cameraCoords(0,0).y>=0) then
            y=0
        end
        --mainPlayer:moveUp();
    elseif y>0 then
        if (cam:cameraCoords(0,0).y<=world.screenY-world.height) then
            y=0
        end
    end
    cam:move(x,y)
end


function writeSaveFile(save)
    save=compress(TSerial.pack(save));
    love.filesystem.setIdentity("bridge_prototype")
    local gameNumber=1
    if love.filesystem.exists('savegame'..gameNumber..'.sav') then
        love.filesystem.remove('savegame'..gameNumber..'.sav')
    end
    local file = love.filesystem.newFile('save.game'..gameNumber..'.sav')
    love.filesystem.write('savegame'..gameNumber..'.sav',save)

end
function loadFile()
    local gameNumber=1
    love.filesystem.setIdentity("bridge_prototype")
     local save=love.filesystem.read('savegame'..gameNumber..'.sav')
    save=TSerial.unpack(decompress(save))
    return save
end

function updateDirt(dt)
    for i,v in ipairs(objects.dirt) do
        v:update(dt)
    end
end


function updateMouseStatus()
   -- local tempXY=cam:worldCoords(love.mouse.getX(),love.mouse.getY())
   -- local mouseX=math.floor(tempXY.x/4)
   -- local mouseY=math.floor(tempXY.y/4)
   -- textBuffer=tiles[mouseX][mouseY]..'name: '..mats[tiles[mouseX][mouseY]][4]
end

function startNewGame()
    if gameMode~='game' then
        if gi:drawLoadingScreen() then
            hump.timer.add(1, function() startNewGame() end)
            return
        end

        cam = hump.camera(hump.vector(world.screenX/2,world.screenY/2))
        setupBackground()
        mainPlayer=player(450,320)
        mainBase=base(350,350)
        res=research()
        brg=bridgeM()
        gi:clickMenu(1)
        gameMode='game'
    end
end

function loadMaterials()
    materials.metals={}
    local save=loadFile()

    for i,v in ipairs(save.metals) do
        print(v.name)
        table.insert(materials.metals,metal(4,4,4,4,v));
    end

end
function loadGame(type)
    if currentMap.loaded then
        gameMode='game'
    end
end

function loadMissionLevel(waterBody)
    gi:closeDialog()
    baseMap=currentMap:unloadMap()
    currentMap=mapGen()
    currentMap:generateLevel(waterBody)
    mainBase:changeMode('mission')
    gi:clickMenu(2)
end
function loadBaseLevel(success)
    gi:closeDialog()
    if success then
        mainBase.level=mainBase.level+1
        mainBase:checkCost(0,0,-currentMap.reward)
    else
        mainBase.level=math.max(1,mainBase.level-1)
    end
    table.insert(missionLevels,currentMap:unloadMap())
    currentMap=baseMap
    mainBase.moving=false
    mainBase:changeMode('base')
    gi:clickMenu(1)
end


















