local metal = {}
metal.__index = metal
local function new(m,t,c,y,load)
    local name,mass,tensile,compressive,young,colour,description
    if type(load)=='table' then
        name,mass,tensile,compressive,young,colour,description=load.name,load.mass,load.tensile,load.compressive,load.young,load.colour,load.description
    else
        name=generateWord(1,3,'metal')
        local rand=(levelsMass[7]-levelsMass[1])/10
        mass=constrain(levelsMass[m]+math.random(-rand,rand)/1000,levelsMass[1],levelsMass[7])
        rand=(levelsTensile[7]-levelsTensile[1])/10
        tensile=constrain(levelsTensile[t]+math.random(-rand,rand),levelsTensile[1],levelsTensile[7])
        rand=(levelsCompressive[7]-levelsCompressive[1])/10
        compressive=constrain(levelsCompressive[c]+math.random(-rand,rand),levelsCompressive[1],levelsCompressive[7])
        rand=(levelsYoung[7]-levelsYoung[1])/10
        young=constrain(levelsYoung[y]+math.random(-rand,rand),levelsYoung[1],levelsYoung[7])
        local cRand=math.random(80,150)
        colour={cRand+math.random(-30,30),cRand+math.random(-30,30),cRand+math.random(-30,30)}
        description=generateDescription(name,mass,tensile,compressive,young)
    end
    return setmetatable({typ='metal',selectedMetal=1,name=name,mass=mass,tensile=tensile,compressive=compressive,young=young,colour=colour,description=description}, metal)
end

function metal:draw()
    love.graphics.point(self.body:getX(),self.body:getY())
end


function metal:click(item)

end
function metal:clickButton(type)

end
function metal:drawButton(x,y,width,height,text)

end
function metal:save()
    return {name=self.name,mass=self.mass,tensile=self.tensile,compressive=self.compressive,young=self.young,colour=self.colour,description=self.description}
end

function generateDescription(name,m,t,c,y)
    local frags={'However, it has terrible','Has very low','Has poor','Has decent','Has very good','Highly prized for its','Known for its incredible '}
    local weights={'Is not much heavier than dense wood','Highly prized for its extremely low weight','Its low weight makes it valuable','Is decently light','Its slightly higher weight makes building with it tricky','Has a very high density.','An extremely dense metal'}
    local youngs={'Unfortunately it is too elastic for most uses.','Stretches a lot under load.','Has a slightly rubbery quality.','Is decently rigid','Does not stretch much under load.','Can support a lot without changing length.','It takes an amazing amount of force to stretch.' }
    local start={'is a shiny silver metal','is known for its corrosion resistance','is a dull coloured metal','has a top layer which oxidises quickly','has a unique pattern on its surface' }
    local desc=name:gsub("^%l", string.upper)..' '..start[math.random(1,#start)]..'. '..weights[chooseDesc(levelsMass,m)]..'. '..frags[chooseDesc(levelsTensile,t)]..' tensile strength. '..frags[chooseDesc(levelsCompressive,c)]..' compressive strength. '..youngs[chooseDesc(levelsYoung,y)]
    return desc
end
function chooseDesc(ta,n)
    local ans=1
    for i,v in ipairs(ta) do
       if n>=v then
        ans=i
       end
    end

    return ans
end

return setmetatable({new = new},
    {__call = function(_, ...) return new(...) end})