function love.load()
	love.keyboard.setKeyRepeat(10, 10)
	makeSomeNoise()
end


function makeSomeNoise()
	noise1,noise2,noise3 = perlin(800, {4,10,20}), perlin(800, {10,50,100}), perlin(800, {10,300})
end


function perlin(n, granulation, seed)
	local function lerp(x,y,t) return x+(y-x)*t end		-- Linear interpolation: Faster, but uglier
	local function cerp(x,y,t) local f=(1-math.cos(t*math.pi))*.5 return x*(1-f)+y*f end		-- Cosine interpolation: Slower, but prettier
	if seed then math.randomseed(seed) math.random() end
	granulation = granulation or {2,8,32}
	local noise = {}
	
	for scalei,scale in ipairs(granulation) do	
		local t = {}
		for i=1,n/scale+scale+1 do t[i] = math.random()-.5 end
		
		for i=1,n do
			local x,y,t = t[math.floor(i/scale)+1], t[math.floor(i/scale)+2], (i%scale)/scale
			noise[i] = (noise[i] or 0) * ((granulation[scalei-1] or 1) / scale) + cerp(x,y,t)
		end
	end
	return noise
end


function love.keypressed(k) if k=="escape" then
    love.event.push("q")
else
    makeSomeNoise() end end


function love.draw()
	local point = love.graphics.point
	love.graphics.setPointSize(2)
	love.graphics.setColor(255,0,0) for x,y in ipairs(noise1) do point(x, y*50+125) end
	love.graphics.setColor(0,255,0) for x,y in ipairs(noise2) do point(x, y*150+225) end
	love.graphics.setColor(0,0,255) for x,y in ipairs(noise3) do point(x, y*250+325) end
end