local material = {}
material.__index = material
local function new(typ,soilType,tileType,load)
    local name=''
    local composeOf={}
    local colour={}
    local description=''
    if load then
        typ=load.typ
        tileType=load.tileType
        name=load.name
        composeOf=load.composeOf
        colour=load.colour
        description=load.description
        soilType=load.soilType
    else
        if (typ=='ore') then
            name=generateWord(1,3,'ore')
            local composedNumber=math.random(2,4)
            local composeCount=math.random(10,50)
            composeOf={{materials.soils[soilType],composeCount}}
            local checkM={}
            for i=1,30 do
               local newM=constrain(soilType*2+math.random(-2,2),1,#materials.metals)
               if not inTable(checkM,newM) then
                   local cTemp=math.random(10,50)
                   composeCount=composeCount+cTemp
                   table.insert(composeOf,{materials.metals[newM],cTemp})
                   table.insert(checkM,newM)
               end
               if #composeOf==composedNumber then
                   break
               end
            end
            for i,v in ipairs(composeOf) do
                v[2]=math.round((v[2]/composeCount)*100)
            end

            local cRand=math.random(100,200)
            colour=mixColours(composeOf)
            description=name:gsub("^%l", string.upper)..' is a metal ore composed of '
            for i,v in ipairs(composeOf) do
                description=description..v[2]..'% '..v[1].name..', '
            end
            description=description..'and trace amounts of other metals.'
        elseif (typ=='soil') then
            composeOf='self'
            name=generateWord(1,1,'soil')
            local cRand=math.random(170-soilType*5,220-soilType*5)
            colour={cRand+20+math.random(-10,10),cRand+math.random(-10,10),cRand-20+math.random(-10,10) }
            local soilDesc={'is a sandy loam.','is a compact soil.','is a sedimentary rock sometimes found near the surface','is a sedimentary rock which usually has high levels of water.','is a hard bedrock; difficult to penetrate.','is a solid rock usually found only at the deepest depths.'}
            description=name:gsub("^%l", string.upper)..' '..soilDesc[soilType]
        end
    end

    return setmetatable({typ=typ,tileType=tileType,name=name,colour=colour,description=description,soilType=soilType}, material)--,composeOf=composeOf
end

function mixColours(comps)
    local tempC={0,0,0 }
    local count=0
    for i,v in ipairs(comps) do
       tempC[1]=tempC[1]+v[1].colour[1]
       tempC[2]=tempC[2]+v[1].colour[2]
       tempC[3]=tempC[3]+v[1].colour[3]
       count=count+1
    end
    tempC[1]=tempC[1]/count
    tempC[2]=tempC[2]/count
    tempC[3]=tempC[3]/count

    return tempC

end
function material:save()
    return {typ=self.typ,tileType=self.tileType,name=self.name,composeOf=self.composeOf,colour=self.colour,description=self.description,soilType=self.soilType}
end

return setmetatable({new = new},
    {__call = function(_, ...) return new(...) end})