local player = {}
player.__index = player
local function new(x,y)
    --local bod = {}
    --bod.b = love.physics.newBody(world.obj, 650/2, 650/2, 15, 0) --place the body in the center of the world, with a mass of 15
    --bod.s = love.physics.newCircleShape(bod.b, 0, 0, 20) --the ball's shape has no offset from it's body and has a radius of 20
    local x=x
    local y=y
    local img=love.graphics.newImage("bot.png")
    return setmetatable({bouyancy=18,inWater=0,direction=1,img=img,xSpeed=0,ySpeed=0,x=x,y=y,onGround=false}, player)
end

function player:draw()
    love.graphics.draw(self.img,self.x-8,self.y-14)
end
function player:moveSide(direction)
    self.xSpeed=direction*(80-50*self.inWater)
    self.direction=direction
end

function player:moveUp()
    if (self.onGround) then
        self.ySpeed=-350
        self.onGround=false;
    elseif (self.inWater==1) then
        self.ySpeed=-self.bouyancy
    elseif currentMap:checkPoint(self.x,self.y)==253 then
        self.ySpeed=-150
    end
end
function player:newCollision(a,coll)
    self.onGround=true;
end

function player:update(dt)
    if love.keyboard.isDown("right") or love.keyboard.isDown("d")then
        mainPlayer:moveSide(1);
    elseif love.keyboard.isDown("left") or love.keyboard.isDown("a")then
         mainPlayer:moveSide(-1);
    end
    if love.keyboard.isDown("up") or love.keyboard.isDown("w")then
        mainPlayer:moveUp();
    elseif love.keyboard.isDown("down") or love.keyboard.isDown("s")then
        if currentMap:checkPoint(self.x,self.y+4)==252 then
            mainPlayer:pushDown()
        end
        --self:dig()
    end
    self.x,self.y,self.xSpeed,self.ySpeed,self.onGround,self.inWater=updateObject(self.x,self.y,self.xSpeed,self.ySpeed,dt,self.bouyancy);
    if self.xSpeed>0 and cam:cameraCoords(self.x,self.y).x>world.screenX*0.6 then
        scrollCam(self.xSpeed*dt,0)
    elseif  self.xSpeed<0 and cam:cameraCoords(self.x,self.y).x<(world.screenX*0.4) then
        scrollCam(self.xSpeed*dt,0)
    end
    if self.ySpeed>0 and cam:cameraCoords(self.x,self.y).y>world.screenY*0.6 then
        scrollCam(0,self.ySpeed*dt)
    elseif  self.ySpeed<0 and cam:cameraCoords(self.x,self.y).y<(world.screenY*0.4) then
        scrollCam(0,self.ySpeed*dt)
    end
    for i=1,3 do
        if currentMap:isSolid(currentMap:checkPoint(self.x,self.y-i*4)) then
            self.y=self.y-4
        end
    end
end
function player:pushDown()
       self.y=self.y+5
end

function player:dig()
    local tX,tY=toGrid(self.x,self.y)
    local type=240
    for i=1,5 do
        for j=1,5 do
            local tempX=tX+i*self.direction
            local tempY=tY+j
        type=currentMap:checkPoint(tempX,tempY,1)
        if currentMap:isSolid(type) then
            currentMap:setPoint(tempX,tempY,255)
            table.insert(objects.dirt,dirt(tempX*4,tempY*4,type,self.direction))
            break
        end
        end
    end
end

return setmetatable({new = new},
    {__call = function(_, ...) return new(...) end})