local research = {}
research.__index = research
local function new()
    cats={
        {{name='shaftDigSpeed',description='Shaft mine digging speed',strength=6,func=function(p) res:setBuildings('shaft','speed',p) end},
            {name='radiusDigSpeed',description='Ore Extractor digging speed',strength=6,func=function(p) res:setBuildings('extractor','speed',p) end},
            {name='dirtCrush',description='Amount of waste dirt',strength=5,func=function(p) res:setBuildings('shaft','crush',p) end},
            {name='mineRadius',description='Radius of Ore Extractor',strength=5,func=function(p) res:setBuildings('extractor','radius',p) end},
        },
        {{name='lightDistance',description='Brightness of lights',strength=6,func=function(p) res:setBuildings('light','distance',p) end},
            {name='lightCost',description='Cost of lights',strength=6,func=function(p) res:setBuildings('light','cost',p) end},
            {name='shaftLightDistance',description='Brightness of lights in shaft mine',strength=6,func=function(p) res:setBuildings('light','brightness',p) end},
        },
        {{name='oreEfficiency',description='Ore processing efficiency',strength=5,func=function(p) res:setBase('material','efficiency',p) end},
            {name='materialEfficiency',description='Material processing efficiency',strength=5,func=function(p) res:setBase('material','processing',p) end},
        },
        {{name='mass',description='Weight of beams reduced',strength=4,func=function(p) res:setMetals('metal','mass',p) end},
            {name='tensile',description='Tensile strength of beams',strength=5,func=function(p) res:setMetals('metal','tensile',p) end},
            {name='compressive',description='Compressive strength of beams',strength=5,func=function(p) res:setMetals('metal','compressive',p) end},
            {name='youngs',description='Rigidity of beams',strength=6,func=function(p) res:setMetals('metal','youngs',p) end},
            {name='beamEfficiency',description='Cost of beams reduced',strength=3,func=function(p) res:setBuildings('bridge','cost',p) end},
            {name='deckMass',description='Weight of deck reduced',strength=6,func=function(p) res:setBuildings('bridge','deck',p) end},
            {name='beamLength',description='Maximum length of beams',strength=2,func=function(p) res:setBuildings('bridge','length',p) end},
            {name='beamLength',description='New Bridge Element!',rare=8,strength=2,func=function(p) res:newBridgeElement() end},
        },
        {{name='maxClimb',description='Maximum climbable gradient',strength=4,func=function(p) res:setBase('base','max',p) end},
            {name='connectSpeed',description='Speed of connecting wire',strength=6,func=function(p) res:setBase('base','speed',p) end},
            {name='baseMass',description='Lighter base',strength=2,func=function(p) res:setBase('base','lighter',p) end},
            {name='controlDepth',description='Deepest build depth',strength=5,func=function(p) res:setBase('base','controlDistance',p) end},
            {name='wheelBase',description='Distance between wheels',strength=3,func=function(p) res:setBase('base','wheelDistance',p) end},
        },
        {{name='newSource',description='New source of energy!',strength=6,func=function(p) res:setBase('energy','new',p) end},
                   {name='powerGeneration',description='Amount of energy produced',strength=6,func=function(p) res:setBase('energy','produced',p) end},
                   {name='increaseLimit',description='Limit in engine type',strength=6,func=function(p) res:setBase('energy','engineLimit',p) end},
                   {name='lightenEngine',description='Lighter energy sources',strength=6,func=function(p) res:setBase('energy','lighter',p) end},
        },
        {{name='CPUconvert',description='Efficiency of CPU conversion',strength=6,func=function(p) res:setBase('cpu','conversion',p) end},
                {name='CPUlimit',description='Limit in storage of CPU',strength=6,func=function(p) res:setBase('cpu','storage',p) end},
        },
        {{name='researchEffectsAmount',description='Number of effects per research',strength=2,func=function(p) res:setResearch('effects','number',p) end},
                {name='researchCPU',description='Reduction in CPU required per research',strength=2,func=function(p) res:setResearch('cpu','required',p) end},
                {name='researchStrength',description='Positive effects of research',strength=2.5,func=function(p) res:setResearch('effects','positive',p) end},
                {name='sideEffectStrength',description='Negative effects of research reduced',strength=1,func=function(p) res:setResearch('effects','negative',p) end},
                {name='insight',description='You learn a deeper understanding of the world. ',strength=0,func=function(p) res:setResearch('effects','none',p) end},
        },
    }
    return setmetatable({negativeMultiplier=1,positiveMultiplier=1,progress=0,cats=cats,effectsNumber=20,result={},CPUneed=20}, research)
end

function research:setMetals(v1,v2,p)
    for i,v in ipairs(materials.metals) do
         if v2=='mass' then
             v.mass=(v.mass/100)*(100+p)
         elseif v2=='tensile' then
             v.tensile=v.tensile/100*(100+p)
         elseif v2=='compressive' then
             v.compressive=v.compressive/100*(100+p)
         elseif v2=='youngs' then
             v.young=v.young/100*(100+p)
         end
    end
end
function research:setBuildings(v1,v2,p)
    if v1=='bridge' then
    for i=102,106 do
        if v2=='cost' then
            buildingTypes[i].cost=buildingTypes[i].cost/100*(100-p)
        elseif v2=='deck' then
            buildingTypes[106].mass=buildingTypes[106].mass/100*(100-p)
            break
        elseif v2=='length' then
            buildingTypes[i].maxLength=buildingTypes[i].maxLength/100*(100+p)
        end
    end
    elseif v1=='light' then
        if v2=='distance' then
            buildingTypes[5].lightStrength=buildingTypes[5].lightStrength/100*(100+p)
        elseif v2=='cost' then
            buildingTypes[5].material=buildingTypes[5].material/100*(100-p)
        elseif v2=='brightness' then
            buildingTypes[1].lightStrength=buildingTypes[1].lightStrength/100*(100+p)
        end
    elseif v1=='extractor' then
        if v2=='speed' then
            buildingTypes[4].speed=buildingTypes[4].speed/100*(100-p)
        elseif v2=='radius' then
            buildingTypes[4].maxDistance=buildingTypes[4].maxDistance/100*(100+p)
        end

    elseif v1=='shaft' then
        if v2=='speed' then
            buildingTypes[1].speed=buildingTypes[1].speed/100*(100-p)
        elseif v2=='crush' then
            buildingTypes[1].crush=buildingTypes[1].crush/100*(100+p)
        end
    end
end
function research:newBridgeElement()
    for i=102,106 do
       if not buildingTypes[i].available then
            buildingTypes[i].available=true
            gi:logText(buildingTypes[i].name..' now available!','research')
        break
       end
    end
end
function research:setBase(v1,v2,p)
    if v1=='cpu' then
        if v2=='conversion' then
            mainBase.cpu.convert=mainBase.cpu.convert/100*(100-p)
        elseif v2=='storage' then
            mainBase.cpu.max=mainBase.cpu.max/100*(100+p)
        end
    elseif v1=='energy' then
        if v2=='produced' then
            mainBase.energy=mainBase.energy/100*(100+p)
        end
    elseif v1=='material' then
        if v2=='efficiency' then
            mainBase.efficiency=mainBase.efficiency/100*(100+p)
        elseif v2=='processing' then
            mainBase.efficiency=mainBase.efficiency/100*(100+p)
        end
    else
        if v2=='max' then
            mainBase.maxClimb=mainBase.maxClimb/100*(100+p)
        elseif v2=='speed' then
            mainBase.speed=mainBase.speed/100*(100-p)
        elseif v2=='lighter' then
            mainBase.mass=mainBase.mass/100*(100-p)
        elseif v2=='wheelDistance' then
            mainBase.wSpacing=mainBase.wSpacing/100*(100+p)
        elseif v2=='controlDistance' then
            mainBase.controlDistance=mainBase.controlDistance/100*(100+p)
        end

    end
end
function research:setResearch(v1,v2,p)
    if v2=='required' then
        self.CPUneed=self.CPUneed/100*(100-p)
    elseif v2=='number' then
        self.effectsNumber=self.effectsNumber/100*(100+p)
    elseif v2=='positive' then
        self.positiveMultiplier=self.positiveMultiplier/100*(100+p)
    elseif v2=='negative' then
        self.negativeMultiplier=self.negativeMultiplier/100*(100-p)
    end
end
function research:create(cat)
    self.result={}
    for g=1,2 do
        local effects=cats[cat]
        local results={}
        local effectsNumber=math.random(20,20+math.round(self.effectsNumber))/10
        local checkE={}
        for i=1,effectsNumber do
            local tempE={}
            for i=1,10 do
                local rand=math.random(1,#effects)
                tempE=table.copy(effects[rand])
                if not inTable(checkE,rand) then
                    if tempE.rare then
                        if math.random(1,10)>tempE.rare then
                            table.insert(checkE,rand)
                            break
                        end
                    else
                        table.insert(checkE,rand)
                        break
                    end
                end
            end
            if tempE.strength>0 then
                tempE.strength=math.random(1,math.floor(tempE.strength*10*self.positiveMultiplier))/5
                if i>1 and math.random(1,10)>5 then
                    tempE.strength=-tempE.strength*self.negativeMultiplier
                end
            end
            table.insert(results,tempE)
        end
        table.insert(self.result,results)
    end
end
function research:click(item)
    if mainBase:checkCost(0,0,self.CPUneed) then
        item=item%100
        self:create(item)
        gi:displayResearch(self.result)
    end
end
function research:choose(item)
    gi.dialogOpen=false
    gi.dialogs={}
    self:applyResearch(self.result[item])

end
function research:applyResearch(result)
    for i,v in ipairs(result) do
       v.func(v.strength)
    end
end

return setmetatable({new = new},
    {__call = function(_, ...) return new(...) end})